unit Wiz97Edt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Wizard97, Wiz97Frm, DsgnIntf, ComCtrls, Grids, ExtCtrls, Menus, StdCtrls;

type
  TWizard97EditorForm = class(TForm)
    pnlHost: TPanel;
    mnuWizEdit: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    View1: TMenuItem;
    Properties1: TMenuItem;
    Preview1: TMenuItem;
    Tree1: TMenuItem;
    Panel1: TPanel;
    scrPreviewBox: TScrollBox; // Size: W=505 H=387
    splMain: TSplitter;
    pnlPages: TPanel;
    splControl: TSplitter;
    pnlProperties: TPanel;
    StringGrid1: TStringGrid;
    pnlTreeView: TPanel;
    trvWizPages: TTreeView;
    pnlPropDesc: TPanel;
    Panel2: TPanel;
    pnlButtonHost: TPanel;
    pnlButtons: TPanel;
    btnOK: TButton;
    btnCancel: TButton;
    btnApply: TButton;
    btnHelp: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    OldWindowProc: TWndMethod;
    procedure PreviewFormClose(Sender: TObject; var Action: TCloseAction);
    procedure PreviewWindowProc(var Message: TMessage);
  public
    PreviewForm: TWizard97Form;
//    FillTreeViewPages;
  end;

  TWizard97Editor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TWizard97PropertyEditor = class(TPropertyEditor)
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

implementation

{$R *.DFM}

var
  Wizard97EditorForm: TWizard97EditorForm;
  EditWizard: TWizard97;

function StartWizardEditor(WizardComponent: TComponent): TModalResult;
begin
  Result := mrCancel;
  if (WizardComponent is TWizard97) then
  try
    EditWizard := TWizard97.Create(Application);
    EditWizard.Assign(WizardComponent as TWizard97);
    Wizard97EditorForm := nil;
    try
      Wizard97EditorForm := TWizard97EditorForm.Create(Application);
      Wizard97EditorForm.ShowModal;
      Result := Wizard97EditorForm.ModalResult;
      if Result = mrOk then
        WizardComponent.Assign(EditWizard);
    finally
      Wizard97EditorForm.Free;
    end;
  finally
    EditWizard.Free;
  end
  else
    ShowMessage('Component to be edited is not of type TWizard97');
end;

procedure TWizard97Editor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0:
      begin
        if StartWizardEditor(TWizard97(Component)) = mrOk then
          Designer.Modified;
      end;
  end;
end;

function TWizard97Editor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Wizard Editor...';
  end;
end;

function TWizard97Editor.GetVerbCount: Integer;
begin
  Result := 1;
end;

// Editor Form
procedure TWizard97EditorForm.FormActivate(Sender: TObject);
begin
  if not Assigned(PreviewForm) then
  begin
    PreviewForm := TWizard97Form.Create(scrPreviewBox);
    with PreviewForm do
    begin
      Parent := scrPreviewBox;
      OnClose := PreviewFormClose;
      Show;
      Top := 0;
      Left := 0;
      Perform(WM_NCACTIVATE, Ord(True), 0); // Change caption to active
      OldWindowProc := WindowProc;
      WindowProc := PreviewWindowProc;
    end;
  end;
end;

procedure TWizard97EditorForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  PreviewForm.WindowProc := OldWindowProc;
  PreviewForm.Free;
  Action := caFree;
end;

procedure TWizard97EditorForm.FormCreate(Sender: TObject);
begin
  PreviewForm := nil;
end;

procedure TWizard97EditorForm.PreviewFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caNone;
end;

procedure TWizard97EditorForm.PreviewWindowProc(var Message: TMessage);
//var
//  WindowPos : TWindowPos;
begin
{  case Message.Msg of
    WM_WINDOWPOSCHANGING :
      begin
        TWMWindowPosChanging(Message).WindowPos.flags :=
          TWMWindowPosChanging(Message).WindowPos.flags or SWP_NOMOVE;
//
//        WindowPos.flags := WindowPos.flags ;
//        scrPreviewBox.EnableAutoRange;
//        scrPreviewBox.
//        scrPreviewBox.HorzScrollBar.Range := TWMMove(Message).XPos + PreviewForm.Width - 4;
//        scrPreviewBox.VertScrollBar.Range := TWMMove(Message).YPos + PreviewForm.Height - 4;
//        Caption := Format('%d, %d', [TWMMove(Message).XPos + PreviewForm.Width, TWMMove(Message).YPos + PreviewForm.Height]);
      end;
  else
}
    OldWindowProc(Message);
//  end;
end;

// TWizard97PropertyEditor
procedure TWizard97PropertyEditor.Edit;
begin
  if StartWizardEditor(TWizard97(GetComponent(0))) = mrOk then
    Modified;
end;

function TWizard97PropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes;
  Result := Result + [paDialog, paReadOnly];
  Result := Result - [paValueList, paSortList, paSubProperties, paMultiSelect];
end;

function TWizard97PropertyEditor.GetValue: string;
begin
  Result := '(TWizardPages)';
end;

procedure TWizard97EditorForm.btnOKClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TWizard97EditorForm.FormShow(Sender: TObject);
var
  I : Integer;
begin
  with trvWizPages.Items do
  try
    BeginUpdate;
    for I := 0 to EditWizard.Pages.PageCount - 1 do
      Add(nil, EditWizard.Pages.Page[I].PageName);
  finally
    EndUpdate;
  end;
end;

end.
